OpenVDB 11.0.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Attributes | Protected Attributes | Friends | List of all members
GradStencil< GridT, IsSafe > Class Template Reference

`#include <openvdb/math/Stencils.h>`

Inheritance diagram for GradStencil< GridT, IsSafe >:

## Public Types
typedef GridT | GridType
typedef GridT::TreeType | TreeType
typedef GridType::ValueType | ValueType
typedef tree::ValueAccessor< const TreeType, IsSafe > | AccessorType
typedef std::vector< ValueType > | BufferType

## Public Member Functions
| GradStencil (const GridType &grid)
| GradStencil (const GridType &grid, Real dx)
ValueType | normSqGrad () const
| Return the norm square of the single-sided upwind gradient (computed via Godunov's scheme) at the previously buffered location.
math::Vec3< ValueType > | gradient () const
| Return the gradient computed at the previously buffered location by second order central differencing.
math::Vec3< ValueType > | gradient (const math::Vec3< ValueType > &V) const
| Return the first-order upwind gradient corresponding to the direction V.
ValueType | laplacian () const
bool | zeroCrossing () const
math::Vec3< ValueType > | cpt ()
| Compute the closest-point transform to a level set.
template<int i, int j, int k>
unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center.
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.
void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil.
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
int | size ()
| Return the size of the stencil buffer.
ValueType | median () const
| Return the median value of the current stencil.
ValueType | mean () const
| Return the mean value of the current stencil.
ValueType | min () const
| Return the smallest value in the stencil buffer.
ValueType | max () const
| Return the largest value in the stencil buffer.
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
bool | intersects (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
std::bitset< 6 > | intersectionMask (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Attributes
static const int | SIZE = 7

## Protected Attributes
const GridType * | mGrid
Coord | mCenter

## Friends
template<typename , typename , bool >
class | BaseStencil

## Detailed Description

template<typename GridT, bool IsSafe = true>
class openvdb::v11_0::math::GradStencil< GridT, IsSafe >

This is a simple 7-point nearest neighbor stencil that supports gradient by second-order central differencing, first-order upwinding, Laplacian, closest-point transform and zero-crossing test.

Note
  For optimal random access performance this class includes its own grid accessor.

## Member Typedef Documentation

## ◆ AccessorType

typedef tree::ValueAccessor<const TreeType, IsSafe> AccessorType
| inherited

## ◆ BufferType

typedef std::vector<ValueType> BufferType
| inherited

## ◆ GridType

template<typename GridT , bool IsSafe = true>

typedef GridT GridType

## ◆ TreeType

template<typename GridT , bool IsSafe = true>

typedef GridT::TreeType TreeType

## ◆ ValueType

template<typename GridT , bool IsSafe = true>

typedef GridType::ValueType ValueType

## Constructor & Destructor Documentation

## ◆ GradStencil() [1/2]

template<typename GridT , bool IsSafe = true>

GradStencil | ( | const GridType & | grid | ) |
| inline

## ◆ GradStencil() [2/2]

template<typename GridT , bool IsSafe = true>

GradStencil | ( | const GridType & | grid,
|  | Real | dx )
| inline

## Member Function Documentation

## ◆ accessor()

const AccessorType & accessor | ( |  | ) | const
| inline inherited

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ cpt()

template<typename GridT , bool IsSafe = true>

math::Vec3< ValueType > cpt | ( |  | ) |
| inline

Compute the closest-point transform to a level set.

Returns
  the closest point in index space to the surface from which the level set was derived.

Note
  This method assumes that the grid represents a level set with distances in world units and a simple affine transfrom with uniform scaling.

## ◆ getCenterCoord()

const Coord & getCenterCoord | ( |  | ) | const
| inline inherited

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

const ValueType & getCenterValue | ( |  | ) | const
| inline inherited

Return the value at the center of the stencil.

## ◆ getValue() [1/2]

const ValueType & getValue | ( |  | ) | const
| inline inherited

Return the value at the specified location relative to the center of the stencil.

## ◆ getValue() [2/2]

const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const
| inline inherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ gradient() [1/2]

template<typename GridT , bool IsSafe = true>

math::Vec3< ValueType > gradient | ( |  | ) | const
| inline

Return the gradient computed at the previously buffered location by second order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ gradient() [2/2]

template<typename GridT , bool IsSafe = true>

math::Vec3< ValueType > gradient | ( | const math::Vec3< ValueType > & | V | ) | const
| inline

Return the first-order upwind gradient corresponding to the direction V.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ grid()

const GridType & grid | ( |  | ) | const
| inline inherited

Return a const reference to the grid from which this stencil was constructed.

## ◆ intersectionMask()

std::bitset< 6 > intersectionMask | ( | const ValueType & | isoValue = zeroVal<ValueType>() | ) | const
| inline inherited

Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use mask.test(2) where mask is ther return value from this function. To check if there are any intersections use mask.any(), and for no intersections use mask.none(). To count the number of intersections use mask.count().

## ◆ intersects()

bool intersects | ( | const ValueType & | isoValue = zeroVal<ValueType>() | ) | const
| inline inherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ laplacian()

template<typename GridT , bool IsSafe = true>

ValueType laplacian | ( |  | ) | const
| inline

Return the Laplacian computed at the previously buffered location by second-order central differencing.

## ◆ max()

ValueType max | ( |  | ) | const
| inline inherited

Return the largest value in the stencil buffer.

## ◆ mean()

ValueType mean | ( |  | ) | const
| inline inherited

Return the mean value of the current stencil.

## ◆ median()

ValueType median | ( |  | ) | const
| inline inherited

Return the median value of the current stencil.

## ◆ min()

ValueType min | ( |  | ) | const
| inline inherited

Return the smallest value in the stencil buffer.

## ◆ moveTo() [1/4]

void moveTo | ( | const Coord & | ijk | ) |
| inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## ◆ moveTo() [2/4]

void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue )
| inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stnecil center
  centerValue | Value of the center element of the stencil

## ◆ moveTo() [3/4]

void moveTo | ( | const IterType & | iter | ) |
| inline inherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Note
  This version is slightly faster than the one above, since the center voxel's value is read directly from the iterator.

## ◆ moveTo() [4/4]

void moveTo | ( | const Vec3< RealType > & | xyz | ) |
| inline inherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## ◆ normSqGrad()

template<typename GridT , bool IsSafe = true>

ValueType normSqGrad | ( |  | ) | const
| inline

Return the norm square of the single-sided upwind gradient (computed via Godunov's scheme) at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ pos()

template<typename GridT , bool IsSafe = true>
template<int i, int j, int k>

unsigned int pos | ( |  | ) | const
| inline

Return linear offset for the specified stencil point relative to its center.

## ◆ setValue()

void setValue | ( | const ValueType & | value | ) |
| inline inherited

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

int size | ( |  | ) |
| inline inherited

Return the size of the stencil buffer.

## ◆ zeroCrossing()

template<typename GridT , bool IsSafe = true>

bool zeroCrossing | ( |  | ) | const
| inline

Return `true` if the sign of the value at the center point of the stencil is different from the signs of any of its six nearest neighbors.

## Friends And Related Symbol Documentation

## ◆ BaseStencil

template<typename GridT , bool IsSafe = true>
template<typename , typename , bool >

friend class BaseStencil
| friend

## Member Data Documentation

## ◆ mCenter

Coord mCenter
| protected inherited

## ◆ mGrid

const GridType* mGrid
| protected inherited

## ◆ SIZE

template<typename GridT , bool IsSafe = true>

const int SIZE = 7
| static